<?php
/**
 * Offers helper functions for language issues
 */
class d2u_machinery_machine_construction_equipment_extension_lang_helper extends d2u_machinery_lang_helper {
	/**
	 * @var string[] Array with englisch replacements. Key is the wildcard,
	 * value the replacement. 
	 */
	protected $replacements_english = [
		'd2u_machinery_construction_equipment_airless_hose_connection' => 'Hose connection',
		'd2u_machinery_construction_equipment_airless_hose_diameter' => 'Hose diameter',
		'd2u_machinery_construction_equipment_airless_hose_length' => 'Hose length',
		'd2u_machinery_construction_equipment_airless_nozzle_size' => 'Nozzle size',
		'd2u_machinery_construction_equipment_container_capacity' => 'Capacity',
		'd2u_machinery_construction_equipment_container_connection_port' => 'Connection Port',
		'd2u_machinery_construction_equipment_container_conveying_wave' => 'Conveying wave',
		'd2u_machinery_construction_equipment_container_mixing_performance' => 'Mixing performance',
		'd2u_machinery_construction_equipment_container_waterconnect' => 'Water connection',
		'd2u_machinery_construction_equipment_container_weight_empty' => 'Empty weight',
		'd2u_machinery_construction_equipment_cutters_cutting_depth' => 'Cutting depth',
		'd2u_machinery_construction_equipment_cutters_cutting_length' => 'Cutting length',
		'd2u_machinery_construction_equipment_cutters_rod_length' => 'Rod length',
		'd2u_machinery_construction_equipment_delivery_sets' => 'Scope of delivery',
		'd2u_machinery_construction_equipment_description_technical' => 'Comments',
		'd2u_machinery_construction_equipment_floor_beam_power_on_concrete' => 'Beam power on concrete',
		'd2u_machinery_construction_equipment_floor_dust_extraction_connection' => 'Dust extraction connection',
		'd2u_machinery_construction_equipment_floor_feedrate' => 'Feedrate',
		'd2u_machinery_construction_equipment_floor_filter_connection' => 'Filter connection',
		'd2u_machinery_construction_equipment_floor_rotations' => 'Rotations',
		'd2u_machinery_construction_equipment_floor_working_pressure' => 'Working pressure',
		'd2u_machinery_construction_equipment_floor_working_width' => 'Working width',
		'd2u_machinery_construction_equipment_grinder_grinding_plate' => 'Grinding plate',
		'd2u_machinery_construction_equipment_grinder_grinding_wheel' => 'Grinding wheels (Ø)',
		'd2u_machinery_construction_equipment_grinder_rotational_frequency' => 'Rotational frequency',
		'd2u_machinery_construction_equipment_grinder_sanding' => 'Sanding',
		'd2u_machinery_construction_equipment_grinder_vacuum_connection' => 'Vacuum connection (Ø)',
		'd2u_machinery_construction_equipment_machine_technique' => 'Machine technique',
		'd2u_machinery_construction_equipment_max' => 'max.',
		'd2u_machinery_construction_equipment_operating_pressure' => 'Operating pressure',
		'd2u_machinery_construction_equipment_pump_conveying_distance_fluid' => 'Conveying distance (fluid materials)',
		'd2u_machinery_construction_equipment_pump_conveying_distance_mineral' => 'Conveying distance (mineral materials)',
		'd2u_machinery_construction_equipment_pump_conveying_distance_pasty' => 'Conveying distance (pasty materials)',
		'd2u_machinery_construction_equipment_pump_filling' => 'Filling',
		'd2u_machinery_construction_equipment_pump_flow_volume_fluid' => 'Delivery rate (fluid materials)',
		'd2u_machinery_construction_equipment_pump_flow_volume_mineral' => 'Delivery rate (mineral materials)',
		'd2u_machinery_construction_equipment_pump_flow_volume_pasty' => 'Delivery rate (pasty materials)',
		'd2u_machinery_construction_equipment_pump_grain_size' => 'Grain size',
		'd2u_machinery_construction_equipment_pump_material_container' => 'Material container',
		'd2u_machinery_construction_equipment_pump_pressure_height_fluid' => 'Pressure height (fluid materials)',
		'd2u_machinery_construction_equipment_pump_pressure_height_mineral' => 'Pressure height (mineral materials)',
		'd2u_machinery_construction_equipment_pump_pressure_height_pasty' => 'Pressure height (pasty materials)',
		'd2u_machinery_construction_equipment_up_to' => 'up to',
		'd2u_machinery_construction_equipment_waste_water_capacity' => 'Capacity',
	];

	/**
	 * @var string[] Array with german replacements. Key is the wildcard,
	 * value the replacement. 
	 */
	protected $replacements_german = [
		'd2u_machinery_construction_equipment_airless_hose_connection' => 'Schlauchanschluss',
		'd2u_machinery_construction_equipment_airless_hose_diameter' => 'Schlauchdurchmesser',
		'd2u_machinery_construction_equipment_airless_hose_length' => 'Schlauchlänge',
		'd2u_machinery_construction_equipment_airless_nozzle_size' => 'Düsengröße',
		'd2u_machinery_construction_equipment_container_capacity' => 'Füllmenge',
		'd2u_machinery_construction_equipment_container_connection_port' => 'Anschluss',
		'd2u_machinery_construction_equipment_container_conveying_wave' => 'Förderwelle',
		'd2u_machinery_construction_equipment_container_mixing_performance' => 'Mischleistung',
		'd2u_machinery_construction_equipment_container_waterconnect' => 'Wasseranschluss',
		'd2u_machinery_construction_equipment_container_weight_empty' => 'Leergewicht',
		'd2u_machinery_construction_equipment_cutters_cutting_depth' => 'Schnitttiefe',
		'd2u_machinery_construction_equipment_cutters_cutting_length' => 'Schnittlänge',
		'd2u_machinery_construction_equipment_cutters_rod_length' => 'Stablänge',
		'd2u_machinery_construction_equipment_delivery_sets' => 'Lieferumfang',
		'd2u_machinery_construction_equipment_description_technical' => 'Bemerkungen',
		'd2u_machinery_construction_equipment_floor_beam_power_on_concrete' => 'Strahlleistung auf Beton',
		'd2u_machinery_construction_equipment_floor_dust_extraction_connection' => 'Anschluß Staubabsaugung',
		'd2u_machinery_construction_equipment_floor_feedrate' => 'Vorschub',
		'd2u_machinery_construction_equipment_floor_filter_connection' => 'Anschluss Filteranlage',
		'd2u_machinery_construction_equipment_floor_rotations' => 'Umdrehungen',
		'd2u_machinery_construction_equipment_floor_working_pressure' => 'Arbeitsdruck',
		'd2u_machinery_construction_equipment_floor_working_width' => 'Arbeitsbreite',
		'd2u_machinery_construction_equipment_grinder_grinding_plate' => 'Schleifplatte',
		'd2u_machinery_construction_equipment_grinder_grinding_wheel' => 'Schleifscheiben (Ø)',
		'd2u_machinery_construction_equipment_grinder_rotational_frequency' => 'Drehfrequenz',
		'd2u_machinery_construction_equipment_grinder_sanding' => 'Schleifhub',
		'd2u_machinery_construction_equipment_grinder_vacuum_connection' => 'Staubsaugeranschluss (Ø)',
		'd2u_machinery_construction_equipment_machine_technique' => 'Maschinentechnik',
		'd2u_machinery_construction_equipment_max' => 'max.',
		'd2u_machinery_construction_equipment_operating_pressure' => 'Betriebsdruck',
		'd2u_machinery_construction_equipment_pump_conveying_distance_fluid' => 'Förderweite (flüssig)',
		'd2u_machinery_construction_equipment_pump_conveying_distance_mineral' => 'Förderweite (mineralisch)',
		'd2u_machinery_construction_equipment_pump_conveying_distance_pasty' => 'Förderweite (pastös)',
		'd2u_machinery_construction_equipment_pump_filling' => 'Einfüllhöhe',
		'd2u_machinery_construction_equipment_pump_flow_volume_fluid' => 'Förderleistung (flüssig)',
		'd2u_machinery_construction_equipment_pump_flow_volume_mineral' => 'Förderleistung (mineralisch)',
		'd2u_machinery_construction_equipment_pump_flow_volume_pasty' => 'Förderleistung (pastös)',
		'd2u_machinery_construction_equipment_pump_grain_size' => 'Korngröße',
		'd2u_machinery_construction_equipment_pump_material_container' => 'Materialbehälter',
		'd2u_machinery_construction_equipment_pump_pressure_height_fluid' => 'Förderhöhe (flüssig)',
		'd2u_machinery_construction_equipment_pump_pressure_height_mineral' => 'Förderhöhe (mineralisch)',
		'd2u_machinery_construction_equipment_pump_pressure_height_pasty' => 'Förderhöhe (pastös)',
		'd2u_machinery_construction_equipment_up_to' => 'bis',
		'd2u_machinery_construction_equipment_waste_water_capacity' => 'Fassungsvermögen',
	];

	/**
	 * @var string[] Array with french replacements. Key is the wildcard,
	 * value the replacement. 
	 */
	protected $replacements_french = [
		'd2u_machinery_construction_equipment_airless_hose_connection' => 'Raccord de tuyau',
		'd2u_machinery_construction_equipment_airless_hose_diameter' => 'Diamètre du tuyau',
		'd2u_machinery_construction_equipment_airless_hose_length' => 'Longueur du tuyau',
		'd2u_machinery_construction_equipment_airless_nozzle_size' => 'Taille de la buse',
		'd2u_machinery_construction_equipment_container_capacity' => 'Capacité',
		'd2u_machinery_construction_equipment_container_connection_port' => 'Connexion',
		'd2u_machinery_construction_equipment_container_conveying_wave' => 'L\'arbre de convoyeur',
		'd2u_machinery_construction_equipment_container_mixing_performance' => 'Performances de mélange',
		'd2u_machinery_construction_equipment_container_waterconnect' => 'connexion d\'eau',
		'd2u_machinery_construction_equipment_container_weight_empty' => 'Poids à vide',
		'd2u_machinery_construction_equipment_cutters_cutting_depth' => 'Profondeur de coupe',
		'd2u_machinery_construction_equipment_cutters_cutting_length' => 'Durée moyenne',
		'd2u_machinery_construction_equipment_cutters_rod_length' => 'Tige de longueur',
		'd2u_machinery_construction_equipment_delivery_sets' => 'Contenu de la livraison',
		'd2u_machinery_construction_equipment_description_technical' => 'Commentaires',
		'd2u_machinery_construction_equipment_floor_beam_power_on_concrete' => 'Puissance de faisceau sur le béton',
		'd2u_machinery_construction_equipment_floor_dust_extraction_connection' => 'Extraction de poussière de connexion',
		'd2u_machinery_construction_equipment_floor_feedrate' => 'Vitesse d\'avance',
		'd2u_machinery_construction_equipment_floor_filter_connection' => 'Système de filtre de connexion',
		'd2u_machinery_construction_equipment_floor_rotations' => 'Révolutions',
		'd2u_machinery_construction_equipment_floor_working_pressure' => 'Pression de travail',
		'd2u_machinery_construction_equipment_floor_working_width' => 'Largeur de travail',
		'd2u_machinery_construction_equipment_grinder_grinding_plate' => 'Surface de meulage',
		'd2u_machinery_construction_equipment_grinder_grinding_wheel' => 'Meule (Ø)',
		'd2u_machinery_construction_equipment_grinder_rotational_frequency' => 'Fréquence de rotation',
		'd2u_machinery_construction_equipment_grinder_sanding' => 'Ponçage',
		'd2u_machinery_construction_equipment_grinder_vacuum_connection' => 'Raccord du vide (Ø)',
		'd2u_machinery_construction_equipment_machine_technique' => 'Technologie de la machine',
		'd2u_machinery_construction_equipment_max' => 'max.',
		'd2u_machinery_construction_equipment_operating_pressure' => 'Pression de service',
		'd2u_machinery_construction_equipment_pump_conveying_distance_fluid' => 'Conveying distance (matériaux liquides)',
		'd2u_machinery_construction_equipment_pump_conveying_distance_mineral' => 'Conveying distance (matériaux minéraux)',
		'd2u_machinery_construction_equipment_pump_conveying_distance_pasty' => 'Conveying distance (matériaux pâteux)',
		'd2u_machinery_construction_equipment_pump_filling' => 'Remplissage',
		'd2u_machinery_construction_equipment_pump_flow_volume_fluid' => 'Volume d\'écoulement (matériaux liquides)',
		'd2u_machinery_construction_equipment_pump_flow_volume_mineral' => 'Volume d\'écoulement (matériaux minéraux)',
		'd2u_machinery_construction_equipment_pump_flow_volume_pasty' => 'Volume d\'écoulement (matériaux pâteux)',
		'd2u_machinery_construction_equipment_pump_grain_size' => 'Taille des grains',
		'd2u_machinery_construction_equipment_pump_material_container' => 'Réservoir de matière',
		'd2u_machinery_construction_equipment_pump_pressure_height_fluid' => 'Hauteur de pression (matériaux liquides)',
		'd2u_machinery_construction_equipment_pump_pressure_height_mineral' => 'Hauteur de pression (matériaux minéraux)',
		'd2u_machinery_construction_equipment_pump_pressure_height_pasty' => 'Hauteur de pression (matériaux pâteux)',
		'd2u_machinery_construction_equipment_up_to' => 'à',
		'd2u_machinery_construction_equipment_waste_water_capacity' => 'Capacité',
	];
	
	/**
	 * Factory method.
	 * @return d2u_machinery_machine_construction_equipment_extension_lang_helper Object
	 */
	public static function factory() {
		return new d2u_machinery_machine_construction_equipment_extension_lang_helper();
	}
}