<?php
/**
 * Offers helper functions for language issues
 */
class d2u_machinery_used_machines_lang_helper extends d2u_machinery_lang_helper {
	/**
	 * @var string[] Array with englisch replacements. Key is the wildcard,
	 * value the replacement. 
	 */
	protected $replacements_english = [
		'd2u_machinery_used_machines' => 'Used machines',
		'd2u_machinery_used_machines_availability' => 'Available',
		'd2u_machinery_used_machines_availible_from' => 'Available from',
		'd2u_machinery_used_machines_config_error' => 'Failure: in the D2U Machinery Addon settings is this article not configured.',
		'd2u_machinery_used_machines_details' => 'Details',
		'd2u_machinery_used_machines_external_url' => 'For more details, see',
		'd2u_machinery_used_machines_infos' => 'more Information',
		'd2u_machinery_used_machines_link_machine' => 'More information on the type of machine',
		'd2u_machinery_used_machines_location' => 'Location',
		'd2u_machinery_used_machines_no_machines' => 'At the moment there are no demonstration / used machines available.',
		'd2u_machinery_used_machines_offer_rent' => 'Rental offer',
		'd2u_machinery_used_machines_offers_rent' => 'Rental offers',
		'd2u_machinery_used_machines_offers_sale' => 'Sale offers',
		'd2u_machinery_used_machines_price' => 'Price',
		'd2u_machinery_used_machines_price_on_request' => 'on request',
		'd2u_machinery_used_machines_vat_excluded' => 'without VAT',
		'd2u_machinery_used_machines_vat_included' => 'VAT included',
		'd2u_machinery_used_machines_year_built' => 'Year of construction',
		];

	/**
	 * @var string[] Array with german replacements. Key is the wildcard,
	 * value the replacement. 
	 */
	protected $replacements_german = [
		'd2u_machinery_used_machines' => 'Gebrauchtmaschinen',
		'd2u_machinery_used_machines_availability' => 'Sofort verfügbar',
		'd2u_machinery_used_machines_availible_from' => 'Verfügbar ab',
		'd2u_machinery_used_machines_config_error' => 'Fehler: in den Einstellungen der D2U Machinery Erweiterung ist dieser Artikel nicht konfiguriert.',
		'd2u_machinery_used_machines_details' => 'Details',
		'd2u_machinery_used_machines_external_url' => 'Details',
		'd2u_machinery_used_machines_infos' => 'Weitere Informationen',
		'd2u_machinery_used_machines_link_machine' => 'Weitere Informationen zum Maschinentyp',
		'd2u_machinery_used_machines_location' => 'Standort',
		'd2u_machinery_used_machines_no_machines' => 'Zur Zeit sind leider keine Vorführ-/Gebrauchtmaschinen vorhanden.',
		'd2u_machinery_used_machines_offer_rent' => 'Mietangebot',
		'd2u_machinery_used_machines_offers_rent' => 'Mietangebote',
		'd2u_machinery_used_machines_offers_sale' => 'Verkaufsangebote',
		'd2u_machinery_used_machines_price' => 'Preis',
		'd2u_machinery_used_machines_price_on_request' => 'auf Anfrage',
		'd2u_machinery_used_machines_vat_excluded' => 'ohne MwSt.',
		'd2u_machinery_used_machines_vat_included' => 'MwSt. enthalten',
		'd2u_machinery_used_machines_year_built' => 'Baujahr'
	];

	/**
	 * @var string[] Array with french replacements. Key is the wildcard,
	 * value the replacement. 
	 */
	protected $replacements_french = [
		'd2u_machinery_used_machines' => 'Machines d\'occasion',
		'd2u_machinery_used_machines_availability' => 'Disponible dès maintenant',
		'd2u_machinery_used_machines_availible_from' => 'Disponible à partir',
		'd2u_machinery_used_machines_config_error' => 'translation missing: d2u_machinery_used_machines_config_error',
		'd2u_machinery_used_machines_details' => 'Détails',
		'd2u_machinery_used_machines_external_url' => 'Détails',
		'd2u_machinery_used_machines_infos' => 'Plus d\'informations',
		'd2u_machinery_used_machines_link_machine' => 'Informations complémentaires au type de machine',
		'd2u_machinery_used_machines_location' => 'translation missing: d2u_machinery_used_machines_location',
		'd2u_machinery_used_machines_no_machines' => 'Pour l\'instant, démonstration / machines d\'occasion ne sont pas disponibles.',
		'd2u_machinery_used_machines_offer_rent' => 'translation missing: d2u_machinery_used_machines_offer_rent',
		'd2u_machinery_used_machines_offers_rent' => 'translation missing: d2u_machinery_used_machines_offers_rent',
		'd2u_machinery_used_machines_offers_sale' => 'translation missing: d2u_machinery_used_machines_offers_sale',
		'd2u_machinery_used_machines_price' => 'translation missing: d2u_machinery_used_machines_price',
		'd2u_machinery_used_machines_price_on_request' => 'translation missing: d2u_machinery_used_machines_price_on_request',
		'd2u_machinery_used_machines_vat_excluded' => 'translation missing: d2u_machinery_used_machines_vat_excluded',
		'd2u_machinery_used_machines_vat_included' => 'translation missing: d2u_machinery_used_machines_vat_included',
		'd2u_machinery_used_machines_year_built' => 'L\'année de construction',
	];

	/**
	 * @var string[] Array with spanish replacements. Key is the wildcard,
	 * value the replacement. 
	 */
	protected $replacements_spanish = [
		'd2u_machinery_used_machines' => 'translation missing: d2u_machinery_used_machines',
		'd2u_machinery_used_machines_availability' => 'Disponible ahora',
		'd2u_machinery_used_machines_availible_from' => 'Disponible a partir de',
		'd2u_machinery_used_machines_config_error' => 'translation missing: d2u_machinery_used_machines_config_error',
		'd2u_machinery_used_machines_details' => 'Detalles',
		'd2u_machinery_used_machines_external_url' => 'Detalles',
		'd2u_machinery_used_machines_infos' => 'Para obtener más información',
		'd2u_machinery_used_machines_link_machine' => 'translation missing: d2u_machinery_used_machines_link_machine',
		'd2u_machinery_used_machines_location' => 'translation missing: d2u_machinery_used_machines_location',
		'd2u_machinery_used_machines_no_machines' => 'translation missing: d2u_machinery_used_machines_no_machines',
		'd2u_machinery_used_machines_offer_rent' => 'translation missing: d2u_machinery_used_machines_offer_rent',
		'd2u_machinery_used_machines_offers_rent' => 'translation missing: d2u_machinery_used_machines_offers_rent',
		'd2u_machinery_used_machines_offers_sale' => 'translation missing: d2u_machinery_used_machines_offers_sale',
		'd2u_machinery_used_machines_price' => 'translation missing: d2u_machinery_used_machines_price',
		'd2u_machinery_used_machines_price_on_request' => 'translation missing: d2u_machinery_used_machines_price_on_request',
		'd2u_machinery_used_machines_vat_excluded' => 'translation missing: d2u_machinery_used_machines_vat_excluded',
		'd2u_machinery_used_machines_vat_included' => 'translation missing: d2u_machinery_used_machines_vat_included',
		'd2u_machinery_used_machines_year_built' => 'Año de construcción',
	];

	/**
	 * @var string[] Array with italian replacements. Key is the wildcard,
	 * value the replacement. 
	 */
	protected $replacements_italian = [
		'd2u_machinery_used_machines' => 'translation missing: d2u_machinery_used_machines',
		'd2u_machinery_used_machines_availability' => 'Disponibile ora',
		'd2u_machinery_used_machines_availible_from' => 'Disponibile da',
		'd2u_machinery_used_machines_config_error' => 'translation missing: d2u_machinery_used_machines_config_error',
		'd2u_machinery_used_machines_details' => 'Dettagli',
		'd2u_machinery_used_machines_external_url' => 'Dettagli',
		'd2u_machinery_used_machines_infos' => 'Per ulteriori informazioni',
		'd2u_machinery_used_machines_link_machine' => 'translation missing: d2u_machinery_used_machines_link_machine',
		'd2u_machinery_used_machines_location' => 'translation missing: d2u_machinery_used_machines_location',
		'd2u_machinery_used_machines_no_machines' => 'translation missing: d2u_machinery_used_machines_no_machines',
		'd2u_machinery_used_machines_offer_rent' => 'translation missing: d2u_machinery_used_machines_offer_rent',
		'd2u_machinery_used_machines_offers_rent' => 'translation missing: d2u_machinery_used_machines_offers_rent',
		'd2u_machinery_used_machines_offers_sale' => 'translation missing: d2u_machinery_used_machines_offers_sale',
		'd2u_machinery_used_machines_price' => 'translation missing: d2u_machinery_used_machines_price',
		'd2u_machinery_used_machines_price_on_request' => 'translation missing: d2u_machinery_used_machines_price_on_request',
		'd2u_machinery_used_machines_vat_excluded' => 'translation missing: d2u_machinery_used_machines_vat_excluded',
		'd2u_machinery_used_machines_vat_included' => 'translation missing: d2u_machinery_used_machines_vat_included',
		'd2u_machinery_used_machines_year_built' => 'Anno costruzione',
	];

	/**
	 * @var string[] Array with polish replacements. Key is the wildcard,
	 * value the replacement. 
	 */
	protected $replacements_polish = [
		'd2u_machinery_used_machines' => 'translation missing: d2u_machinery_used_machines',
		'd2u_machinery_used_machines_availability' => 'Już dostępny',
		'd2u_machinery_used_machines_availible_from' => 'Dostępne od',
		'd2u_machinery_used_machines_config_error' => 'translation missing: d2u_machinery_used_machines_config_error',
		'd2u_machinery_used_machines_details' => 'Detale',
		'd2u_machinery_used_machines_external_url' => 'Detale',
		'd2u_machinery_used_machines_infos' => 'Aby uzyskać więcej informacji',
		'd2u_machinery_used_machines_link_machine' => 'translation missing: d2u_machinery_used_machines_link_machine',
		'd2u_machinery_used_machines_location' => 'translation missing: d2u_machinery_used_machines_location',
		'd2u_machinery_used_machines_no_machines' => 'translation missing: d2u_machinery_used_machines_no_machines',
		'd2u_machinery_used_machines_offer_rent' => 'translation missing: d2u_machinery_used_machines_offer_rent',
		'd2u_machinery_used_machines_offers_rent' => 'translation missing: d2u_machinery_used_machines_offers_rent',
		'd2u_machinery_used_machines_offers_sale' => 'translation missing: d2u_machinery_used_machines_offers_sale',
		'd2u_machinery_used_machines_price' => 'translation missing: d2u_machinery_used_machines_price',
		'd2u_machinery_used_machines_price_on_request' => 'translation missing: d2u_machinery_used_machines_price_on_request',
		'd2u_machinery_used_machines_vat_excluded' => 'translation missing: d2u_machinery_used_machines_vat_excluded',
		'd2u_machinery_used_machines_vat_included' => 'translation missing: d2u_machinery_used_machines_vat_included',
		'd2u_machinery_used_machines_year_built' => 'Rok budowy',
	];
	
	/**
	 * @var string[] Array with dutch replacements. Key is the wildcard,
	 * value the replacement. 
	 */
	protected $replacements_dutch = [
		'd2u_machinery_used_machines' => 'translation missing: d2u_machinery_used_machines',
		'd2u_machinery_used_machines_availability' => 'Nu beschikbaar',
		'd2u_machinery_used_machines_availible_from' => 'Beschikbaar vanaf',
		'd2u_machinery_used_machines_config_error' => 'translation missing: d2u_machinery_used_machines_config_error',
		'd2u_machinery_used_machines_details' => 'Details',
		'd2u_machinery_used_machines_external_url' => 'Details',
		'd2u_machinery_used_machines_infos' => 'Voor meer informatie',
		'd2u_machinery_used_machines_link_machine' => 'translation missing: d2u_machinery_used_machines_link_machine',
		'd2u_machinery_used_machines_location' => 'translation missing: d2u_machinery_used_machines_location',
		'd2u_machinery_used_machines_no_machines' => 'translation missing: d2u_machinery_used_machines_no_machines',
		'd2u_machinery_used_machines_offer_rent' => 'translation missing: d2u_machinery_used_machines_offer_rent',
		'd2u_machinery_used_machines_offers_rent' => 'translation missing: d2u_machinery_used_machines_offers_rent',
		'd2u_machinery_used_machines_offers_sale' => 'translation missing: d2u_machinery_used_machines_offers_sale',
		'd2u_machinery_used_machines_price' => 'translation missing: d2u_machinery_used_machines_price',
		'd2u_machinery_used_machines_price_on_request' => 'translation missing: d2u_machinery_used_machines_price_on_request',
		'd2u_machinery_used_machines_vat_excluded' => 'translation missing: d2u_machinery_used_machines_vat_excluded',
		'd2u_machinery_used_machines_vat_included' => 'translation missing: d2u_machinery_used_machines_vat_included',
		'd2u_machinery_used_machines_year_built' => 'Bouwjaar',
	];

	/**
	 * @var string[] Array with czech replacements. Key is the wildcard,
	 * value the replacement. 
	 */
	protected $replacements_czech = [
		'd2u_machinery_used_machines' => 'Použité stroje',
		'd2u_machinery_used_machines_availability' => 'nyní k dispozici',
		'd2u_machinery_used_machines_availible_from' => 'Dostupný od',
		'd2u_machinery_used_machines_config_error' => 'translation missing: d2u_machinery_used_machines_config_error',
		'd2u_machinery_used_machines_details' => 'Podrobnosti',
		'd2u_machinery_used_machines_external_url' => 'Podrobnosti',
		'd2u_machinery_used_machines_infos' => 'Pro více informací',
		'd2u_machinery_used_machines_link_machine' => 'Více informací o typu stroje',
		'd2u_machinery_used_machines_location' => 'translation missing: d2u_machinery_used_machines_location',
		'd2u_machinery_used_machines_no_machines' => 'V současné době nejsou k dispozici žádné  použité stroje.',
		'd2u_machinery_used_machines_offer_rent' => 'translation missing: d2u_machinery_used_machines_offer_rent',
		'd2u_machinery_used_machines_offers_rent' => 'translation missing: d2u_machinery_used_machines_offers_rent',
		'd2u_machinery_used_machines_offers_sale' => 'translation missing: d2u_machinery_used_machines_offers_sale',
		'd2u_machinery_used_machines_price' => 'translation missing: d2u_machinery_used_machines_price',
		'd2u_machinery_used_machines_price_on_request' => 'translation missing: d2u_machinery_used_machines_price_on_request',
		'd2u_machinery_used_machines_vat_excluded' => 'translation missing: d2u_machinery_used_machines_vat_excluded',
		'd2u_machinery_used_machines_vat_included' => 'translation missing: d2u_machinery_used_machines_vat_included',
		'd2u_machinery_used_machines_year_built' => 'translation missing: d2u_machinery_used_machines_year_built',
	];

	/**
	 * @var string[] Array with russian replacements. Key is the wildcard,
	 * value the replacement. 
	 */
	protected $replacements_russian = [
		'd2u_machinery_used_machines' => 'translation missing: d2u_machinery_used_machines',
		'd2u_machinery_used_machines_availability' => 'теперь доступен',
		'd2u_machinery_used_machines_availible_from' => 'Доступна с',
		'd2u_machinery_used_machines_config_error' => 'translation missing: d2u_machinery_used_machines_config_error',
		'd2u_machinery_used_machines_details' => 'Детали',
		'd2u_machinery_used_machines_external_url' => 'Детали',
		'd2u_machinery_used_machines_infos' => 'Для получения дополнительной информации',
		'd2u_machinery_used_machines_link_machine' => 'translation missing: d2u_machinery_used_machines_link_machine',
		'd2u_machinery_used_machines_location' => 'translation missing: d2u_machinery_used_machines_location',
		'd2u_machinery_used_machines_no_machines' => 'translation missing: d2u_machinery_used_machines_no_machines',
		'd2u_machinery_used_machines_offer_rent' => 'translation missing: d2u_machinery_used_machines_offer_rent',
		'd2u_machinery_used_machines_offers_rent' => 'translation missing: d2u_machinery_used_machines_offers_rent',
		'd2u_machinery_used_machines_offers_sale' => 'translation missing: d2u_machinery_used_machines_offers_sale',
		'd2u_machinery_used_machines_price' => 'translation missing: d2u_machinery_used_machines_price',
		'd2u_machinery_used_machines_price_on_request' => 'translation missing: d2u_machinery_used_machines_price_on_request',
		'd2u_machinery_used_machines_vat_excluded' => 'translation missing: d2u_machinery_used_machines_vat_excluded',
		'd2u_machinery_used_machines_vat_included' => 'translation missing: d2u_machinery_used_machines_vat_included',
		'd2u_machinery_used_machines_year_built' => 'год постройки',
	];

	/**
	 * @var string[] Array with portuguese replacements. Key is the wildcard,
	 * value the replacement. 
	 */
	protected $replacements_portuguese = [
		'd2u_machinery_used_machines' => 'translation missing: d2u_machinery_used_machines',
		'd2u_machinery_used_machines_availability' => 'Disponível agora',
		'd2u_machinery_used_machines_availible_from' => 'Disponível a partir de',
		'd2u_machinery_used_machines_config_error' => 'translation missing: d2u_machinery_used_machines_config_error',
		'd2u_machinery_used_machines_details' => 'detalhes',
		'd2u_machinery_used_machines_external_url' => 'detalhes',
		'd2u_machinery_used_machines_infos' => 'Para mais informações',
		'd2u_machinery_used_machines_link_machine' => 'translation missing: d2u_machinery_used_machines_link_machine',
		'd2u_machinery_used_machines_location' => 'translation missing: d2u_machinery_used_machines_location',
		'd2u_machinery_used_machines_no_machines' => 'translation missing: d2u_machinery_used_machines_no_machines',
		'd2u_machinery_used_machines_offer_rent' => 'translation missing: d2u_machinery_used_machines_offer_rent',
		'd2u_machinery_used_machines_offers_rent' => 'translation missing: d2u_machinery_used_machines_offers_rent',
		'd2u_machinery_used_machines_offers_sale' => 'translation missing: d2u_machinery_used_machines_offers_sale',
		'd2u_machinery_used_machines_price' => 'translation missing: d2u_machinery_used_machines_price',
		'd2u_machinery_used_machines_price_on_request' => 'translation missing: d2u_machinery_used_machines_price_on_request',
		'd2u_machinery_used_machines_vat_excluded' => 'translation missing: d2u_machinery_used_machines_vat_excluded',
		'd2u_machinery_used_machines_vat_included' => 'translation missing: d2u_machinery_used_machines_vat_included',
		'd2u_machinery_used_machines_year_built' => 'translation missing: d2u_machinery_used_machines_year_built',
	];

	/**
	 * @var string[] Array with chinese replacements. Key is the wildcard,
	 * value the replacement. 
	 */
	protected $replacements_chinese = [
		'd2u_machinery_used_machines' => '二手机器',
		'd2u_machinery_used_machines_availability' => '现已上市',
		'd2u_machinery_used_machines_availible_from' => '从可用',
		'd2u_machinery_used_machines_config_error' => 'translation missing: d2u_machinery_used_machines_config_error',
		'd2u_machinery_used_machines_details' => '详细信息',
		'd2u_machinery_used_machines_external_url' => '详细信息',
		'd2u_machinery_used_machines_infos' => '其他信息',
		'd2u_machinery_used_machines_link_machine' => 'translation missing: d2u_machinery_used_machines_link_machine',
		'd2u_machinery_used_machines_location' => 'translation missing: d2u_machinery_used_machines_location',
		'd2u_machinery_used_machines_no_machines' => '目前有示范/二手设备可用。',
		'd2u_machinery_used_machines_offer_rent' => 'translation missing: d2u_machinery_used_machines_offer_rent',
		'd2u_machinery_used_machines_offers_rent' => 'translation missing: d2u_machinery_used_machines_offers_rent',
		'd2u_machinery_used_machines_offers_sale' => 'translation missing: d2u_machinery_used_machines_offers_sale',
		'd2u_machinery_used_machines_price' => 'translation missing: d2u_machinery_used_machines_price',
		'd2u_machinery_used_machines_price_on_request' => 'translation missing: d2u_machinery_used_machines_price_on_request',
		'd2u_machinery_used_machines_vat_excluded' => 'translation missing: d2u_machinery_used_machines_vat_excluded',
		'd2u_machinery_used_machines_vat_included' => 'translation missing: d2u_machinery_used_machines_vat_included',
		'd2u_machinery_used_machines_year_built' => '今年建成',
	];
	
	/**
	 * Factory method.
	 * @return d2u_machinery_used_machines_lang_helper Object
	 */
	public static function factory() {
		return new d2u_machinery_used_machines_lang_helper();
	}
}